function set_rainbow_hexagon(circle, valid)
	if circle then
		local texture = valid and "assets/hexagons/guis/textures/pd2/hud_progress_active" or "assets/hexagons/guis/textures/pd2/hud_progress_invalid"
		circle._circle:set_image(texture)
		circle._bg_circle:set_image("assets/hexagons/guis/textures/pd2/hud_progress_bg")
		circle._circle:set_blend_mode("normal")
		circle._circle:set_alpha(0.9) -- change if you want
	end
end

if RequiredScript == "lib/managers/hud/hudinteraction" then
	Hooks:PostHook(HUDInteraction, "show_interaction_bar" , "hexagon_hudinteraction_show_interaction_bar" , function(self)
		set_rainbow_hexagon(self._interact_circle, true)
	end)
	
	local original_hide_interaction_bar = HUDInteraction.hide_interaction_bar
	function HUDInteraction:hide_interaction_bar(complete, ...)
		-- Disable completion animation
		original_hide_interaction_bar(self, false, ...)
	end
	
	Hooks:PostHook(HUDInteraction, "set_bar_valid" , "hexagon_hudinteraction_set_bar_valid" , function(self, valid)
		set_rainbow_hexagon(self._interact_circle, valid)
	end)
end

if RequiredScript == "lib/managers/hud/hudteammate" then
	Hooks:PostHook(HUDTeammate, "teammate_progress" , "hexagon_hudteammate_teammate_progress" , function(self, enabled)
		self._player_panel:child("radial_health_panel"):set_alpha(enabled and 0.9 or 1)
	end)
end

if RequiredScript == "lib/managers/hudmanagerpd2" then
	Hooks:PostHook(HUDManager, "_add_name_label" , "hexagon_hudmanagerpd2_add_name_label" , function(self)
		pcall(function(self)
			for _, label in pairs(self._hud.name_labels) do
				set_rainbow_hexagon(label.interact, true)
			end
		end, self)
	end)

	local original_teammate_progress = HUDManager.teammate_progress
	function HUDManager:teammate_progress(peer_id, type_index, enabled, tweak_data_id, timer, success, ...)
		-- Disable completion animation
		original_teammate_progress(self, peer_id, type_index, enabled, tweak_data_id, timer, false, ...)
	end
end
